#include "extern.h"

// PARENT CENTRED BLX ///////////////////////////////////////
void xPC_BLX(double d, double *P1, double *P2, 
                       double *Hijo1, double *Hijo2){

  double I, A1, C1;
     
  for (int i=0; i< Genes; i++)
  {
        
     I= d * fabs(P1[i]-P2[i]);
     
     A1=P1[i]-I; if (A1<Gene[i].min) A1=Gene[i].min;
     C1=P1[i]+I; if (C1>Gene[i].max) C1=Gene[i].max;
     Hijo1[i]= A1 + Rand()*(C1-A1);

     A1=P2[i]-I; if (A1<Gene[i].min) A1=Gene[i].min;
     C1=P2[i]+I; if (C1>Gene[i].max) C1=Gene[i].max;
     Hijo2[i]= A1 + Rand()*(C1-A1);
  }      
}
/******************/
/* CRUCE BLX-ALFA */
/******************/

void CruceBLX(double *Padre1, double *Padre2, 
              double *Hijo1,  double *Hijo2){

  int mom, dad, i, j;
  double temp, px, py, I;
  
  alfa=0.5;
  for (j=0; j< Genes; j++)
    {
      px=Padre1[j];  py=Padre2[j];
      
      if (px > py){temp=px; px=py; py=temp;}
      I=py-px; px=px-I*alfa; py=py+I*alfa;
      
      if (px < Gene[j].min) px=Gene[j].min;
      if (py > Gene[j].max) py=Gene[j].max;
      
      Hijo1[j]=px + Rand()*(py-px); Hijo2[j]=px + Rand()*(py-px);
    }
}

/**********************************************************/
/* Itoc and Ctoi translate ints to strings and vice versa */
/**********************************************************/
unsigned long int Ctoi(char *Cad_ent,  int length){

      int i;		
	unsigned long n;	
	
	n = (unsigned long) 0;
	for (i=0; i<length; i++)
	  {
	    n <<= 1;
	    n += (*Cad_ent++ - (int) '0');
	  }
	return(n);
}

void Itoc(unsigned long int n, char *Cad_sal, int length){

  int i;		
  
  for (i=length-1; i>=0; i--)
    {
      Cad_sal[i] = '0' + (n & 1);
      n >>= 1;
    }
}


/*****************************************************************/
/* Translations between fixed point ints and reflected Gray code */
/*****************************************************************/

void Gray(char *Cad_ent, char *Cad_sal, int length){

  int i;
  char last;

  last = '0';
  for (i=0; i<length; i++)
    {
      Cad_sal[i] = '0' + (Cad_ent[i] != last);
      last = Cad_ent[i];
    }
}

/*************************************************************************/
/* Translations between string representation and floating point vectors */
/*************************************************************************/
void StringRep(double *vect, char *Cad_sal, int length){

  int i;		
  unsigned long int n;	
  int pos;	
  char tmpstring[80];	
  double INCREMENTO;	
  
  pos = 0;
  for (i=0; i < length; i++)
    {
      INCREMENTO=(Gene[i].max-Gene[i].min)/(pow(2.0, (double) BITS_GEN) - 1.0);
      
      n = (int) ((vect[i] - Gene[i].min) / INCREMENTO + 0.5);
      
      Itoc(n, tmpstring, BITS_GEN);
      Gray(tmpstring, &Cad_sal[pos], BITS_GEN);
      
      pos += BITS_GEN;
    }
  Cad_sal[pos] = '\0';
}

/*****************************************/
int DistHam(char *Cr_1, char *Cr_2){
  
  int i, dist;
  
  for (i=0, dist=0; i<Genes*BITS_GEN; i++) if (Cr_1[i]!=Cr_2[i]) dist++;
  
  return dist ;
}

/**********************/
/* OPERADOR DE CRUCE  */
/**********************/

void Cruce(){

  int i, j, temp, mom, dad;
  char String1[3000], String2[3000];
  
  /************************************************************************/
  /* BARRAJAR POSICIONES DE CROMOSOMAS A CRUZAR */
  
  for (i=0; i<Popsize; i++) sample[i] = i;
  
  for (i=0; i<Popsize; i++) 
    {
      j = Randint(i,Popsize-1); 
      temp = sample[j]; 
      sample[j] = sample[i]; 
      sample[i] = temp;
    }
  
  for (i=0; i<2*Popsize; i++) Poblacion[i].HaEntrado=0;
  
  /************************************************************************/
  /*  DISPARAR CRUCE */ 
  POPSIZE=Popsize;
  for (i=0; i<Popsize/2; i++)
    {
      mom=sample[2*i]; dad=sample[2*i+1];
      
      /* COMPROBAR DISTANCIA HAMMING ENTRE LOS PADRES */
      StringRep(Poblacion[mom].Gene, String1, Genes);
      StringRep(Poblacion[dad].Gene, String2, Genes);
      
      if (DistHam(String1, String2)/2.0 > THRESHOLD)
	{
	
//	  CruceBLX(Poblacion[mom].Gene, Poblacion[dad].Gene,
//		   Poblacion[POPSIZE].Gene, Poblacion[POPSIZE+1].Gene);
	  
        xPC_BLX(1  , Poblacion[mom].Gene, 
                     Poblacion[dad].Gene,
		         Poblacion[POPSIZE].Gene, 
                     Poblacion[POPSIZE+1].Gene);
	  	  
        Poblacion[POPSIZE].HaEntrado=1;
	  Poblacion[POPSIZE+1].HaEntrado=1;
	  POPSIZE=POPSIZE+2;  
	}
    }
}
/** Fin del Fichero **/
